=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: laminar
 Section: devel
 Priority: optional
-Maintainer: Ruben Pollan <meskio@sindominio.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ruben Pollan <meskio@sindominio.net>
 Build-Depends:
  capnproto (>= 0.7.0~),
  debhelper-compat (= 13),
@@ -16,11 +17,11 @@
  libjs-chart.js,
  libjs-ansi-up,
  libsqlite3-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://laminar.ohwg.net
-Vcs-Browser: https://salsa.debian.org/meskio-guest/laminar/
-Vcs-Git: https://salsa.debian.org/meskio-guest/laminar.git
+Vcs-Browser: https://salsa.debian.org/debian/laminar/
+Vcs-Git: https://salsa.debian.org/debian/laminar.git
 
 Package: laminar
 Architecture: all
