=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%laminar-$1.tar.gz%" \
https://github.com/ohwgiles/laminar/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
